Index: libgo/go/syscall/socket.go
===================================================================
--- libgo/go/syscall/socket.go	(.../tags/gcc_4_7_2_release)	(wersja 194650)
+++ libgo/go/syscall/socket.go	(.../branches/gcc-4_7-branch)	(wersja 194650)
@@ -87,12 +87,16 @@
 	for i := 0; i < n; i++ {
 		sa.raw.Path[i] = int8(name[i])
 	}
+	// length is family (uint16), name, NUL.
+	sl := 2 + Socklen_t(n) + 1
 	if sa.raw.Path[0] == '@' {
 		sa.raw.Path[0] = 0
+		// Don't count trailing NUL for abstract address.
+		sl--
 	}
 
 	// length is family (uint16), name, NUL.
-	return (*RawSockaddrAny)(unsafe.Pointer(&sa.raw)), 2 + Socklen_t(n) + 1, nil
+	return (*RawSockaddrAny)(unsafe.Pointer(&sa.raw)), sl, nil
 }
 
 func anyToSockaddr(rsa *RawSockaddrAny) (Sockaddr, error) {
Index: libgo/go/syscall/syscall_linux_386.go
===================================================================
--- libgo/go/syscall/syscall_linux_386.go	(.../tags/gcc_4_7_2_release)	(wersja 194650)
+++ libgo/go/syscall/syscall_linux_386.go	(.../branches/gcc-4_7-branch)	(wersja 194650)
@@ -8,13 +8,9 @@
 
 import "unsafe"
 
-func (r *PtraceRegs) PC() uint64 {
-	return uint64(uint32(r.Eip))
-}
+func (r *PtraceRegs) PC() uint64 { return uint64(uint32(r.Eip)) }
 
-func (r *PtraceRegs) SetPC(pc uint64) {
-	r.Eip = int32(pc)
-}
+func (r *PtraceRegs) SetPC(pc uint64) { r.Eip = int32(pc) }
 
 func PtraceGetRegs(pid int, regsout *PtraceRegs) (err error) {
 	return ptrace(PTRACE_GETREGS, pid, 0, uintptr(unsafe.Pointer(regsout)))
Index: libgo/go/syscall/exec_windows.go
===================================================================
--- libgo/go/syscall/exec_windows.go	(.../tags/gcc_4_7_2_release)	(wersja 194650)
+++ libgo/go/syscall/exec_windows.go	(.../branches/gcc-4_7-branch)	(wersja 194650)
@@ -132,7 +132,10 @@
 // getFullPath retrieves the full path of the specified file.
 // Just a wrapper for Windows GetFullPathName api.
 func getFullPath(name string) (path string, err error) {
-	p := StringToUTF16Ptr(name)
+	p, err := utf16PtrFromString(name)
+	if err != nil {
+		return "", err
+	}
 	buf := make([]uint16, 100)
 	n, err := GetFullPathName(p, uint32(len(buf)), &buf[0], nil)
 	if err != nil {
@@ -261,7 +264,10 @@
 			return 0, 0, err
 		}
 	}
-	argv0p := StringToUTF16Ptr(argv0)
+	argv0p, err := utf16PtrFromString(argv0)
+	if err != nil {
+		return 0, 0, err
+	}
 
 	var cmdline string
 	// Windows CreateProcess takes the command line as a single string:
@@ -275,12 +281,18 @@
 
 	var argvp *uint16
 	if len(cmdline) != 0 {
-		argvp = StringToUTF16Ptr(cmdline)
+		argvp, err = utf16PtrFromString(cmdline)
+		if err != nil {
+			return 0, 0, err
+		}
 	}
 
 	var dirp *uint16
 	if len(attr.Dir) != 0 {
-		dirp = StringToUTF16Ptr(attr.Dir)
+		dirp, err = utf16PtrFromString(attr.Dir)
+		if err != nil {
+			return 0, 0, err
+		}
 	}
 
 	// Acquire the fork lock so that no other threads
Index: libgo/go/syscall/socket_linux.go
===================================================================
--- libgo/go/syscall/socket_linux.go	(.../tags/gcc_4_7_2_release)	(wersja 194650)
+++ libgo/go/syscall/socket_linux.go	(.../branches/gcc-4_7-branch)	(wersja 194650)
@@ -103,7 +103,7 @@
 	// to be uninterpreted fixed-size binary blobs--but
 	// everyone uses this convention.
 	n := 0
-	for n < len(sa.Path) - 3 && sa.Path[n] != 0 {
+	for n < len(sa.Path) && sa.Path[n] != 0 {
 		n++
 	}
 
Index: libgo/go/syscall/syscall.go
===================================================================
--- libgo/go/syscall/syscall.go	(.../tags/gcc_4_7_2_release)	(wersja 194650)
+++ libgo/go/syscall/syscall.go	(.../branches/gcc-4_7-branch)	(wersja 194650)
@@ -16,18 +16,47 @@
 
 import "unsafe"
 
-// StringByteSlice returns a NUL-terminated slice of bytes
-// containing the text of s.
+// StringByteSlice returns a NUL-terminated slice of bytes containing the text of s.
+// If s contains a NUL byte this function panics instead of
+// returning an error.
 func StringByteSlice(s string) []byte {
+	a, err := byteSliceFromString(s)
+	if err != nil {
+		panic("syscall: string with NUL passed to StringByteSlice")
+	}
+	return a
+}
+
+// byteSliceFromString returns a NUL-terminated slice of bytes
+// containing the text of s. If s contains a NUL byte at any
+// location, it returns (nil, EINVAL).
+func byteSliceFromString(s string) ([]byte, error) {
+	for i := 0; i < len(s); i++ {
+		if s[i] == 0 {
+			return nil, EINVAL
+		}
+	}
 	a := make([]byte, len(s)+1)
 	copy(a, s)
-	return a
+	return a, nil
 }
 
-// StringBytePtr returns a pointer to a NUL-terminated array of bytes
-// containing the text of s.
+// StringBytePtr returns a pointer to a NUL-terminated array of bytes containing the text of s.
+// If s contains a NUL byte this function panics instead of
+// returning an error.
 func StringBytePtr(s string) *byte { return &StringByteSlice(s)[0] }
 
+// bytePtrFromString returns a pointer to a NUL-terminated array of
+// bytes containing the text of s. If s contains a NUL byte at any
+// location, it returns (nil, EINVAL).
+func bytePtrFromString(s string) (*byte, error) {
+	a, err := byteSliceFromString(s)
+	if err != nil {
+		return nil, err
+	}
+	return &a[0], nil
+}
+
 // Single-word zero for use when we need a valid pointer to 0 bytes.
 // See mksyscall.pl.
 var _zero uintptr
Index: libgo/Makefile.am
===================================================================
--- libgo/Makefile.am	(.../tags/gcc_4_7_2_release)	(wersja 194650)
+++ libgo/Makefile.am	(.../branches/gcc-4_7-branch)	(wersja 194650)
@@ -715,6 +715,7 @@
 	go/net/lookup_unix.go \
 	go/net/mac.go \
 	go/net/net.go \
+	go/net/net_posix.go \
 	go/net/parse.go \
 	go/net/pipe.go \
 	go/net/port.go \
Index: libgfortran/runtime/environ.c
===================================================================
--- libgfortran/runtime/environ.c	(.../tags/gcc_4_7_2_release)	(wersja 194650)
+++ libgfortran/runtime/environ.c	(.../branches/gcc-4_7-branch)	(wersja 194650)
@@ -446,21 +446,35 @@
 {
   int low, high, mid;
 
-  low = -1;
-  high = n_elist;
-  while (high - low > 1)
+  if (n_elist == 0)
     {
+      *ip = 0;
+      return 0;
+    }
+
+  low = 0;
+  high = n_elist - 1;
+
+  do 
+    {
       mid = (low + high) / 2;
-      if (unit <= elist[mid].unit)
-	high = mid;
+      if (unit == elist[mid].unit)
+	{
+	  *ip = mid;
+	  return 1;
+	}
+      else if (unit > elist[mid].unit)
+	low = mid + 1;
       else
-	low = mid;
-    }
-  *ip = high;
-  if (elist[high].unit == unit)
-    return 1;
+	high = mid - 1;
+    } while (low <= high);
+
+  if (unit > elist[mid].unit)
+    *ip = mid + 1;
   else
-    return 0;
+    *ip = mid;
+
+  return 0;
 }
 
 /* This matches a keyword.  If it is found, return the token supplied,
@@ -575,13 +589,13 @@
     }
   if (search_unit (unit, &i))
     {
-      elist[unit].conv = endian;
+      elist[i].conv = endian;
     }
   else
     {
-      for (j=n_elist; j>=i; j--)
+      for (j=n_elist-1; j>=i; j--)
 	elist[j+1] = elist[j];
-    
+
       n_elist += 1;
       elist[i].unit = unit;
       elist[i].conv = endian;
Index: libgfortran/ChangeLog
===================================================================
--- libgfortran/ChangeLog	(.../tags/gcc_4_7_2_release)	(wersja 194650)
+++ libgfortran/ChangeLog	(.../branches/gcc-4_7-branch)	(wersja 194650)
@@ -1,3 +1,11 @@
+2012-10-12  Thomas König  <tkoenig@gcc.gnu.org>
+
+	PR libfortran/54736
+	Backport from trunk
+	* runtime/environ.c (search_unit):  Correct logic
+	for binary search.
+	(mark_single):  Fix index errors.
+
 2012-09-20  Release Manager
 
 	* GCC 4.7.2 released.
Index: libffi/ChangeLog
===================================================================
--- libffi/ChangeLog	(.../tags/gcc_4_7_2_release)	(wersja 194650)
+++ libffi/ChangeLog	(.../branches/gcc-4_7-branch)	(wersja 194650)
@@ -1,3 +1,12 @@
+2012-09-20  Jakub Jelinek  <jakub@redhat.com>
+
+	PR other/43620
+	* configure.ac (AM_INIT_AUTOMAKE): Add no-dist.
+	* Makefile.in: Regenerated.
+	* include/Makefile.in: Regenerated.
+	* man/Makefile.in: Regenerated.
+	* testsuite/Makefile.in: Regenerated.
+
 2012-09-20  Release Manager
 
 	* GCC 4.7.2 released.
Index: libffi/configure.ac
===================================================================
--- libffi/configure.ac	(.../tags/gcc_4_7_2_release)	(wersja 194650)
+++ libffi/configure.ac	(.../branches/gcc-4_7-branch)	(wersja 194650)
@@ -12,7 +12,7 @@
 
 . ${srcdir}/configure.host
 
-AM_INIT_AUTOMAKE
+AM_INIT_AUTOMAKE([no-dist])
 
 # The same as in boehm-gc and libstdc++. Have to borrow it from there.
 # We must force CC to /not/ be precious variables; otherwise
Index: libcpp/po/ChangeLog
===================================================================
--- libcpp/po/ChangeLog	(.../tags/gcc_4_7_2_release)	(wersja 194650)
+++ libcpp/po/ChangeLog	(.../branches/gcc-4_7-branch)	(wersja 194650)
@@ -1,3 +1,11 @@
+2012-09-26  Joseph Myers  <joseph@codesourcery.com>
+
+	* sv.po: Update.
+
+2012-09-25  Joseph Myers  <joseph@codesourcery.com>
+
+	* vi.po: Update.
+
 2012-09-20  Release Manager
 
 	* GCC 4.7.2 released.
